import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _extends from "@babel/runtime/helpers/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import './CodeGenActionBtn.scss';
import React, { useState } from 'react';
import * as CodeGenerator from 'lowcode-code-generator-ccs/standalone-loader';
import { TransformStage } from '@alilc/lowcode-types';
import { Button, Drawer, Loading, Message, Dialog, Select } from '@alifd/next';
import coerce from 'semver/functions/coerce';
import { CodeGenResult } from '../CodeGenResult';
var json = '{ "componentName": "Page", "id": "node_dockcviv8fo2", "props": { "ref": "outerView", "style": { "height": "100%" } }, "fileName": "/plyTest2", "dataSource": { "list": [{ "type": "fetch", "isInit": true, "options": { "params": {}, "method": "GET", "isCors": true, "timeout": 5000, "headers": {}, "uri": "http://127.0.0.1:4523/m1/1062213-0-default/pet/findByStatus" }, "id": "fethchPetFindByStatus" }] }, "state": { "text": { "type": "JSExpression", "value": "\\"outer\\"" }, "isShowDialog": { "type": "JSExpression", "value": "false" }, "loading": { "type": "JSExpression", "value": "false" } }, "css": "body {\\n  font-size: 12px;\\n}\\n\\n.button {\\n  width: 100px;\\n  color: #ff00ff\\n}", "lifeCycles": { "componentDidMount": { "type": "JSFunction", "value": "function componentDidMount() {\\n  console.log(\'did mount\');\\n  this.setState({\\n    loading: true\\n  });\\n  window.fetch(\'http://127.0.0.1:4523/m1/1062213-0-default/pet/findByStatus\').then(res => res.json()).then(getlovs => {\\n    this.setState({\\n      getlovs\\n    });\\n  }).catch(err => console.error(err)).then(() => {\\n    this.setState({\\n      loading: false\\n    });\\n  });\\n}" }, "componentWillUnmount": { "type": "JSFunction", "value": "function componentWillUnmount() {\\n  console.log(\'will unmount\');\\n}" } }, "methods": { "testFunc": { "type": "JSFunction", "value": "function testFunc() {\\n  console.log(\'test func\');\\n}" }, "onClick": { "type": "JSFunction", "value": "function onClick() {\\n  this.setState({\\n    isShowDialog: true\\n  });\\n}" }, "closeDialog": { "type": "JSFunction", "value": "function closeDialog() {\\n  this.setState({\\n    isShowDialog: false\\n  });\\n}" } }, "originCode": "class LowcodeComponent extends Component {\\n  state = {\\n    \\"text\\": \\"outer\\",\\n    \\"isShowDialog\\": false,\\n    \\"loading\\": false,\\n  }\\n  componentDidMount() {\\n    console.log(\'did mount\');\\n    this.setState({ loading: true })\\n    window.fetch(\'http://127.0.0.1:4523/m1/1062213-0-default/pet/findByStatus\')\\n      .then((res) => res.json())\\n      .then((getlovs) => {\\n        this.setState({\\n          getlovs,\\n        })\\n      })\\n      .catch(err => console.error(err))\\n      .then(() => {\\n        this.setState({ loading: false })\\n      })\\n  }\\n  componentWillUnmount() {\\n    console.log(\'will unmount\');\\n  }\\n  testFunc() {\\n    console.log(\'test func\');\\n  }\\n  onClick() {\\n    this.setState({\\n      isShowDialog: true\\n    })\\n  }\\n  closeDialog() {\\n    this.setState({\\n      isShowDialog: false\\n    })\\n  }\\n}", "title": "", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextPage", "id": "node_ockzs2vw431", "props": { "headerDivider": true, "minHeight": "100vh", "presetNav": true, "presetAside": true, "footer": false, "nav": false, "aside": false, "placeholderStyle": { "gridRowEnd": "span 1", "gridColumnEnd": "span 12" }, "headerProps": { "background": "surface" }, "header": { "type": "JSSlot", "value": [{ "componentName": "NextPageHeader", "id": "node_ockzs2vw433", "props": {}, "title": "页面头部", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextRowColContainer", "id": "node_ockzs2vw434", "props": { "rowGap": 20, "colGap": 20 }, "title": "行列容器", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextRow", "id": "node_ockzs2vw435", "props": {}, "title": "行", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextCol", "id": "node_ockzs2vw436", "props": { "colSpan": 1 }, "title": "列", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextP", "id": "node_ockzvfoetv17", "props": { "wrap": false, "type": "body2", "verAlign": "middle", "textSpacing": true, "align": "left" }, "docId": "dockzvfoetv", "title": "段落", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextText", "id": "node_ockzvfoetv18", "props": { "type": "h5", "children": { "type": "JSExpression", "value": "this.state.info?.info", "mock": "标题标题" }, "mark": false, "code": false, "delete": false, "underline": false, "strong": false }, "docId": "dockzvfoetv", "title": "", "isLocked": false, "condition": true, "conditionGroup": "" }] }] }] }] }] }], "title": "header" }, "isTab": false, "contentAlignCenter": false, "contentProps": { "style": { "background": "rgba(255,255,255,0)" } }, "ref": "nextpage-de6a8a51" }, "title": "页面", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextBlock", "id": "node_ocl43zma4k3m", "props": { "placeholderStyle": { "height": "100%" }, "noPadding": false, "noBorder": false, "title": "区域标题", "rowGap": 20, "colGap": 20, "background": "surface", "layoutmode": "O", "strict": true, "colSpan": 12, "rowSpan": 1, "mode": "transparent", "childTotalColumns": 12 }, "title": "区域", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextBlockCell", "id": "node_ocl43zma4k3n", "props": { "colSpan": 12, "rowSpan": 1, "mode": "procard", "isAutoContainer": true, "title": "2222222222222222222\\n\\n", "hasDivider": true, "loading": false, "bodyPadding": "", "hasCollapse": false, "text": true, "visibleButtonCount": 3, "operationConfig": { "align": "center" }, "operations": [], "ref": "nextblockcell-44a0fd6f" }, "title": "", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextRowColContainer", "id": "node_ocl43zma4k3o", "props": { "rowGap": 20, "colGap": 20 }, "title": "行列容器", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextRow", "id": "node_ocl43zma4k3p", "props": {}, "title": "行", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextCol", "id": "node_ocl43zma4k3q", "props": { "colSpan": 1, "justifyContent": "flex-start", "ref": "nextcol-f2fe3ba6" }, "title": "列", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "NextP", "id": "node_ocl43zma4k3r", "props": { "wrap": false, "type": "body2", "verAlign": "middle", "textSpacing": true, "align": "left", "ref": "nextp-9ae47b61" }, "title": "段落", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "Filter", "id": "node_ockt5mo4jj1", "props": { "labelAlign": "top", "cols": 4, "operationConfig": { "visibleButtonCount": 3 }, "operations": [], "ref": "filter-3b896c8d" }, "title": "", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "FormInput", "id": "node_ocl442klmcx", "props": { "formItemProps": { "primaryKey": "9948", "label": "code", "size": "medium", "device": "desktop", "fullWidth": true, "columnSpan": 1, "required": false }, "placeholder": "请输入", "size": "medium", "ref": "forminput-a1ce5278" }, "title": "", "isLocked": false, "condition": true, "conditionGroup": "" }, { "componentName": "FormInput", "id": "node_ocl442klmcy", "props": { "formItemProps": { "primaryKey": "7346", "label": "lovId", "size": "medium", "device": "desktop", "fullWidth": true, "columnSpan": 1, "required": false }, "placeholder": "请输入", "size": "medium", "ref": "forminput-3d407f6d" }, "title": "", "isLocked": false, "condition": true, "conditionGroup": "" }] }, { "componentName": "Loading", "id": "node_ocl442knu46", "props": { "color": "red", "prefix": "next-", "tipAlign": "bottom", "visible": { "type": "JSExpression", "value": "this.state.loading" }, "size": "large", "inline": true, "ref": "loading-ae90b49b" }, "title": "", "isLocked": false, "condition": true, "conditionGroup": "", "children": [{ "componentName": "Image", "id": "node_ocl60ixj3q2", "props": { "src": { "type": "JSExpression", "value": "this.state.fethchPetFindByStatus", "mock": "" }, "title": "", "alt": "", "ref": "image-04d24958" }, "title": "图片", "isLocked": false, "condition": true, "conditionGroup": "" }, { "componentName": "ProTable", "id": "node_ocl43zma4k3s", "props": { "dataSource": { "type": "JSExpression", "value": "this.state.fethchPetFindByStatus" }, "actionColumnButtons": { "dataSource": [{ "children": "查看", "type": "primary" }, { "children": "编辑", "type": "primary", "disabled": true }, { "children": "删除", "type": "primary" }], "text": true, "visibleButtonCount": 3 }, "actionBarButtons": { "dataSource": [{ "type": "primary", "children": "操作一" }, { "type": "normal", "children": "操作二" }], "visibleButtonCount": 3 }, "paginationProps": { "pageSize": 20, "current": 1, "hidden": false }, "settingButtons": true, "columns": [{ "title": "id", "dataIndex": "id", "width": 160, "formatType": "text", "searchable": true }, { "title": "name", "dataIndex": "name", "formatType": "text" }, { "title": "category.name", "formatType": "text", "dataIndex": "category.name" }], "actionColumnProps": { "title": "操作", "width": 120 }, "indexColumn": false, "hasBorder": false, "isZebra": false, "fixedHeader": false, "size": "medium", "ref": "protable-8d992dcc" }, "docId": "docl43zma4k", "title": "", "isLocked": false, "condition": true, "conditionGroup": "" }] }] }] }] }] }] }] }] }] }';
export function CodeGenActionBtn(_ref) {
  var _React$createElement;

  var ctx = _ref.ctx;

  var _useState = useState({
    lowCodeTemplate: 'icejs',
    dialogVisible: false,
    visible: false,
    hasError: false,
    error: null,
    loading: false,
    result: null,
    schema: null,
    originalSchema: null
  }),
      state = _useState[0],
      setState = _useState[1];

  var handleClick = function handleClick() {
    setState(function (prev) {
      return _extends({}, prev, {
        dialogVisible: true
      });
    });
  };

  var onOk = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var originalSchema, schema, result;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              console.log(state.lowCodeTemplate); // 打开基于 Gravity 的编辑器/出码预览器

              setState(function (prev) {
                return _extends({}, prev, {
                  dialogVisible: false,
                  loading: true,
                  visible: true,
                  hasError: false
                });
              }); // 获取 schema，并修正

              _context.next = 5;
              return ctx.project.exportSchema(TransformStage.Save);

            case 5:
              originalSchema = _context.sent;
              console.log("获取schema");
              console.log(originalSchema);
              console.log(JSON.stringify(originalSchema)); // @ts-ignore

              originalSchema.componentsTree.push(JSON.parse(json));
              _context.next = 12;
              return fixSchema(originalSchema);

            case 12:
              schema = _context.sent;
              console.log('got fix schema: ', schema);
              setState(function (prev) {
                return _extends({}, prev, {
                  schema: schema,
                  originalSchema: originalSchema
                });
              }); // 出码...

              _context.next = 17;
              return CodeGenerator.generateCode({
                solution: state.lowCodeTemplate,
                schema: schema,
                flattenResult: true
              });

            case 17:
              result = _context.sent;
              console.log('generated: ', result);
              setState(function (prev) {
                return _extends({}, prev, {
                  loading: false,
                  result: result
                });
              });
              _context.next = 26;
              break;

            case 22:
              _context.prev = 22;
              _context.t0 = _context["catch"](0);
              console.error('failed to run code generator: ', _context.t0);
              setState(function (prev) {
                return _extends({}, prev, {
                  hasError: true,
                  error: _context.t0 instanceof Error ? _context.t0 : new Error("" + ((_context.t0 === null || _context.t0 === void 0 ? void 0 : _context.t0.message) || _context.t0))
                });
              });

            case 26:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 22]]);
    }));

    return function onOk() {
      return _ref2.apply(this, arguments);
    };
  }();

  var onChange = function onChange(selectKey) {
    console.log(selectKey);
    setState(function (prev) {
      return _extends({}, prev, {
        lowCodeTemplate: selectKey
      });
    });
  };

  var onClose = function onClose() {
    console.log("selectKey");
    setState(function (prev) {
      return _extends({}, prev, {
        dialogVisible: false
      });
    });
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: handleClick
  }, "\u51FA\u7801"), /*#__PURE__*/React.createElement(Dialog, {
    v2: true,
    title: "\u8BF7\u9009\u62E9\u51FA\u7801\u65B9\u6848",
    visible: state.dialogVisible,
    autoFocus: true,
    onOk: onOk,
    onClose: onClose,
    onCancel: onClose,
    style: {
      width: '25%'
    }
  }, /*#__PURE__*/React.createElement(Select, (_React$createElement = {
    label: "\u65B9\u6848\u540D\u79F0\uFF1A",
    style: {
      width: '100px'
    },
    value: state.lowCodeTemplate,
    onChange: onChange,
    popupProps: {
      v2: true
    }
  }, _React$createElement["style"] = {
    marginLeft: 8
  }, _React$createElement), /*#__PURE__*/React.createElement(Select.Option, {
    value: "icejs"
  }, "\u9ED8\u8BA4\u98DE\u51B0\u51FA\u7801"), /*#__PURE__*/React.createElement(Select.Option, {
    value: "icejsccs"
  }, "ccs\u5B9A\u5236\u51FA\u7801"), /*#__PURE__*/React.createElement(Select.Option, {
    value: "rax"
  }, "\u8DE8\u5BB9\u5668rax\u51FA\u7801"))), /*#__PURE__*/React.createElement(Drawer, {
    visible: state.visible,
    title: "\u51FA\u7801\u7ED3\u679C",
    width: "95vw",
    onClose: function onClose() {
      setState(function (prev) {
        return _extends({}, prev, {
          visible: false
        });
      });
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "code-gen-plugin-result"
  }, function () {
    if (state.hasError) {
      var _state$error;

      return /*#__PURE__*/React.createElement(Message, {
        type: "error",
        title: "\u51FA\u9519\u4E86"
      }, (_state$error = state.error) === null || _state$error === void 0 ? void 0 : _state$error.message);
    }

    if (state.loading) {
      return /*#__PURE__*/React.createElement(Loading, {
        className: "code-gen-plugin-loading",
        tip: "\u6B63\u5728\u51FA\u7801..."
      });
    }

    return /*#__PURE__*/React.createElement(CodeGenResult, {
      result: state.result,
      schema: state.schema,
      originalSchema: state.originalSchema
    });
  }())));
}
export function fixSchema(_x) {
  return _fixSchema.apply(this, arguments);
}

function _fixSchema() {
  _fixSchema = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(schema) {
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", deepClone(_extends({}, schema, {
              componentsMap: schema.componentsMap.filter(function (c) {
                return c["package"];
              }) // 去掉没有 package 的组件
              .map(function (c) {
                // 修正版本号（对于没有有效版本号的组件，默认使用 latest）
                if (!isValidVersion(c.version)) {
                  console.warn('[WARN] got invalid version "%o" for component "%s", use "latest" as fallback', c.version, c);
                  return _extends({}, c, {
                    version: 'latest'
                  });
                } // 修正 @alifd/pro-layout 的版本
                // -- 这个包没有 ^0.1.0 的版本，这里暂且替换下


                if (c["package"] === '@alifd/pro-layout' && c.version === '^0.1.0') {
                  console.warn('[WARN] got invalid version "%o" for "@alifd/pro-layout"! use "latest" as fallback', c.version);
                  return _extends({}, c, {
                    version: 'latest'
                  });
                }

                return c;
              })
            })));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _fixSchema.apply(this, arguments);
}

function deepClone(x) {
  try {
    return JSON.parse(JSON.stringify(x));
  } catch (e) {
    throw new Error("failed to clone schema -- " + e);
  }
}

function isValidVersion(version) {
  if (!version) {
    return false;
  } // 对于一些明显非法的版本号过滤下


  if (version === '{{version}}' || version === 'null' || version === 'undefined') {
    return false;
  } // 对于 latest/beta/rc 这样的 tag 版本号要支持下


  if (/^[a-z][a-z0-9]+([a-z0-9-]+)?$/i.test(version)) {
    return true;
  } // 最后支持下所有 semver 能识别的版本


  return coerce(version) !== null;
}